#define G_LOG_DOMAIN "ap-ability"

#include "ap-ability.h"

#include <math.h>
#include <glib.h>

typedef struct _APAbilityPrivate
{
    gchar *name;
    gchar *label;
    gint   score;
    gint   bonus;
    gint   modifier;
} APAbilityPrivate;

struct _APAbility
{
    GObject parent_instance;
};

G_DEFINE_TYPE_WITH_PRIVATE (APAbility, ap_ability, G_TYPE_OBJECT)

enum
{
    PROP_0,
    PROP_NAME,
    PROP_LABEL,
    PROP_SCORE,
    PROP_BONUS,
    N_PROPERTIES
};

static GParamSpec *obj_properties[N_PROPERTIES] = { NULL, };

void
ap_ability_calculate_modifier (APAbility *self)
{
    APAbilityPrivate *priv = ap_ability_get_instance_private (self);

    /* TODO: WRONG */
    g_print ("%i\n", priv->score);
    g_print ("%i\n", priv->score - 10);
    g_print ("%d\n", (priv->score - 10) / 2);
    g_print ("%e\n", floor ((priv->score - 10) / 2));

    priv->modifier = floor ((priv->score - 10) / 2);
}

static void
ap_ability_set_property (GObject      *object,
                         guint         property_id,
                         const GValue *value,
                         GParamSpec   *pspec)
{
    APAbility *self = AP_ABILITY (object);
    APAbilityPrivate *priv = ap_ability_get_instance_private (self);

    switch (property_id)
    {
        case PROP_NAME:
            priv->name = g_value_dup_string (value);
            break;

        case PROP_LABEL:
            priv->label = g_value_dup_string (value);
            break;

        case PROP_SCORE:
            priv->score = g_value_get_int (value);
            break;

        case PROP_BONUS:
            priv->bonus = g_value_get_uint (value);
            break;

        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
            break;
    }
}

static void
ap_ability_get_property (GObject      *object,
                         guint         property_id,
                         GValue       *value,
                         GParamSpec   *pspec)
{
    APAbility *self = AP_ABILITY (object);
    APAbilityPrivate *priv = ap_ability_get_instance_private (self);

    switch (property_id)
    {
        case PROP_NAME:
            g_value_set_string (value, priv->name);
            break;

        case PROP_LABEL:
            g_value_set_string (value, priv->label);
            break;

        case PROP_SCORE:
            g_value_set_int (value, priv->score);
            break;

        case PROP_BONUS:
            g_value_set_uint (value, priv->bonus);
            break;

        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
            break;
    }
}

static void
ap_ability_finalize (GObject *object)
{
   // APAbilityPrivate *priv = ap_ability_get_instance_private (AP_ABILITY (object));

    G_OBJECT_CLASS (ap_ability_parent_class)->finalize (object);
}

static void
ap_ability_dispose (GObject *object)
{
    //APAbilityPrivate *priv = ap_ability_get_instance_private (AP_ABILITY (object));

    G_OBJECT_CLASS (ap_ability_parent_class)->finalize (object);
}

static void
ap_ability_init (APAbility *self)
{
    //APAbilityPrivate *priv = ap_ability_get_instance_private (self);
}

static void
ap_ability_class_init (APAbilityClass *klass)
{
    GObjectClass *object_class = G_OBJECT_CLASS (klass);

    object_class->set_property = ap_ability_set_property;
    object_class->get_property = ap_ability_get_property;
    object_class->finalize = ap_ability_finalize;
    object_class->dispose = ap_ability_dispose;

    obj_properties[PROP_NAME] =
        g_param_spec_string ("name",
                             "name",
                             "Name of the ability.",
                             NULL,  /* default value */
                             G_PARAM_CONSTRUCT_ONLY | G_PARAM_READWRITE);

    obj_properties[PROP_LABEL] =
        g_param_spec_string ("label",
                             "label",
                             "Display name of the ability.",
                             NULL, /* default value */
                             G_PARAM_READWRITE);

    obj_properties[PROP_SCORE] =
        g_param_spec_int ("score",
                          "score",
                          "The ability score level.",
                          0,
                          100,
                          0, /* default value */
                          G_PARAM_READWRITE);

    obj_properties[PROP_BONUS] =
        g_param_spec_uint ("bonus",
                           "bonus",
                           "The ability score bonus.",
                           0,
                           100,
                           0, /* default value */
                           G_PARAM_READWRITE);

    g_object_class_install_properties (object_class,
                                       N_PROPERTIES,
                                       obj_properties);
}

/*
 * *****************************************************************************
 *
 * API
 *
 * *****************************************************************************
 */
APAbility *
ap_ability_new (void)
{
    return g_object_new (AP_TYPE_ABILITY,
                         NULL);
}

gchar *
ap_ability_get_name (APAbility *self)
{
    APAbilityPrivate *priv = ap_ability_get_instance_private (self);

    return priv->name;
}

gchar *
ap_ability_get_label (APAbility *self)
{
    APAbilityPrivate *priv = ap_ability_get_instance_private (self);

    return priv->label;
}

gint
ap_ability_get_score (APAbility *self)
{
    APAbilityPrivate *priv = ap_ability_get_instance_private (self);

    return priv->score;
}

gint
ap_ability_get_bonus (APAbility *self)
{
    APAbilityPrivate *priv = ap_ability_get_instance_private (self);

    return priv->bonus;
}

gint
ap_ability_get_modifier (APAbility *self)
{
    APAbilityPrivate *priv = ap_ability_get_instance_private (self);

    ap_ability_calculate_modifier (self);

    return priv->modifier;
}
