#ifndef __AP_CHARACTER_H__
#define __AP_CHARACTER_H__

#include "ap-ability.h"
#include "ap-skill.h"
#include "ap-attack.h"

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define AP_TYPE_CHARACTER (ap_character_get_type ())

G_DECLARE_FINAL_TYPE (APCharacter, ap_character, AP, CHARACTER, GObject)

APCharacter *
ap_character_new (void);

APCharacter *
ap_character_from_file (const gchar *filename);

void
ap_character_add_ability (APCharacter *self,
                          APAbility   *ability);

GList *
ap_character_get_abilities (APCharacter *self);

void
ap_character_add_skill (APCharacter *self,
                        APSkill     *skill);

GList *
ap_character_get_skills (APCharacter *self);

void
ap_character_add_attack (APCharacter *self,
                         APAttack    *attack);

GList *
ap_character_get_attacks (APCharacter *self);

void
ap_character_print (APCharacter *self);

G_END_DECLS

#endif /* __AP_CHARACTER_H__ */

