#ifndef __AP_SHEET_H__
#define __AP_SHEET_H__

#include "game.h"
#include "bio.h"
#include "stats.h"
#include "attacks.h"
#include "inventory.h"

#include <glib-object.h>
#include <libxml/tree.h>

G_BEGIN_DECLS

#define AP_TYPE_SHEET (ap_sheet_get_type ())

G_DECLARE_FINAL_TYPE (APSheet, ap_sheet, AP, SHEET, GObject)

typedef struct _APSheetXml {
	APGameXml game;
	APBioXml bio;
	APStatsXml stats;
	APAttacksXml attacks;
	APInventoryXml inventory;
} APSheetXml;

APSheet *
ap_sheet_new (void);

APSheet *
ap_sheet_from_file (const gchar *filename);

void
ap_sheet_save_to_file (APSheet     *self,
                       const gchar *filename);

void
ap_sheet_save_to_current_file (APSheet *self);

void
ap_sheet_load_from_file (APSheet     *self,
                         const gchar *filename);

xmlDoc *
ap_sheet_get_doc (APSheet *self);

xmlNode *
ap_sheet_add_section (APSheet     *self,
                      const gchar *section_name);

xmlNode *
ap_sheet_add_section_with (APSheet     *self,
                           const gchar *section_name,
                           xmlNode     *node);

xmlNode *
ap_sheet_section_add (APSheet     *self,
                      const gchar *section_name,
                      xmlNode     *node);

G_END_DECLS

#endif /* __AP_SHEET_H__ */

